```@meta
CurrentModule = QuantumLattices.Essentials
```

# [Introduction](@id essentials)

Essentials of the package, whose constants, types and functions will be imported when using `import QuantumLattices` or `using QuantumLattices`. Note that this submodule depends on the `Prerequisites` and `Mathematics` submodules although the variables in them are not exported to the scope of `QuantumLattices` by default.

```@contents
Pages = [
        "QuantumOperators.md",
        "QuantumNumbers.md",
        "Spatials.md",
        "DegreesOfFreedom.md",
        "QuantumSystems.md",
        "Frameworks.md",
        ]
Depth = 2
```
